
GPEMetFull <- function(y,X,C,BETApriorM=NULL,BETApriorV=NULL,BETAv=NULL,S2prior,S2priorM,S2priorV,
                       S2v,CLprior,CLv,CEN,q,Nv,iter,adaptive,
                       CORRFUN="Gaussian",ZEROMEAN=FALSE,SLEEP=c(0),filename=NULL){
  nc<- nrow(C)
  n <- nrow(X)
  out<-as.data.frame(matrix(NA,nrow = iter,ncol = 13 + nc))
  NAMES<-c();for(i in 1:nc) NAMES[i]<- paste(c("Cen",row.names(C)[i]),sep="",collapse="")
  names(out) <- c("b0","b1","b2","b3","b4","b5","s2","CL1","CL2","CL3","CL4","CL5","Nugget",NAMES)
  C <- as.matrix(C,ncol=5);y <- as.matrix(y,ncol=1);X <- as.matrix(X,ncol=5)
  if(isTRUE(ZEROMEAN)){
    H <- NULL
    Hc <- NULL
    bigH <- NULL
    BETA <- NULL
  }else{
    if(q==1){
      H <- as.matrix(rep(1,n),ncol=q)
      Hc <- as.matrix(rep(1,nc),ncol=q)
      bigH <- as.matrix(rbind(Hc,H),ncol=q)
    }else{
      H <- as.matrix(cbind(rep(1,n),X),ncol=6)
      Hc <- as.matrix(cbind(rep(1,nc),C),ncol=6)
      bigH <- as.matrix(rbind(Hc,H),ncol=6)
    }
  }
  DATA <- as.matrix(rbind(C,X),ncol=5)
  out[1,]<-c(rep(0,6),rep(5,6),0.1,rep(1.05*CEN,nc))
  if(!is.null(filename)){
    write.table(out[1,],paste(filename),row.names=F,
                col.names=names(out))
  }
  sigAlpha <- S2priorM^2/S2priorV+2
  sigBeta <- S2priorM*(S2priorM^2/S2priorV+1)
  pb <- txtProgressBar(min = 0, max = iter, style = 3)
  for(i in 2:iter){
    if(length(which(SLEEP==i))>0) Sys.sleep(10)
    #i=2
    #Copy the correlation lengths for now
    out[i,8:12] <- out[i-1,8:12]
    nugget <- out[i-1,13]
    Y <- c(as.numeric(out[i-1,14:ncol(out)]),y)
    #Scale the data and create a new correlation matrix
    #Censored values come first
    DATAs <- DATA
    for(o in 1:5) DATAs[,o] <- DATA[,o]/out[i,7+o]
    if(CORRFUN=="Gaussian"){
      SIGMA <- exp(-distance(DATAs))+diag(nugget,n+nc) 
    }else if(CORRFUN=="Matern3_2"){
      D <- sqrt(distance(DATAs))
      SIGMA <- (1+sqrt(3)*D)*exp(-sqrt(3)*D)+diag(nugget,n+nc)
    }else if(CORRFUN=="Matern5_2"){
      D <- sqrt(distance(DATAs))
      SIGMA <- (1+sqrt(5)*D+5/3*D^2)*exp(-sqrt(5)*D)+diag(nugget,n+nc)
    }
    #Partition the correlation matrix so that it's easier to work with
    #Censored values come first
    Sigma11 <- SIGMA[1:nc,1:nc];A <- SIGMA[(nc+1):(nc+n),(nc+1):(nc+n)]
    Ai <- spdinv(A)
    Sigma12 <- SIGMA[1:nc,(nc+1):(nc+n)]
    Sigma21 <- t(Sigma12)
    if(!isTRUE(ZEROMEAN)){
      if(q==1){
        BETA <- out[i-1,1]
      }else{
        BETA <- out[i-1,1:6]
      }
    }
    #S2 update
    S2 <- out[i-1,7]
    out[i,7] <- S2
    S2new <- rlnorm(1,log(S2),sqrt(S2v))
    AA <- dinvgamma(S2new,sigAlpha,sigBeta,log=TRUE)+
      LO(H=bigH,y=Y,beta=BETA,s2=S2new,SIGMA=SIGMA,ZEROMEAN=ZEROMEAN)+dlnorm(S2,log(S2new),sqrt(S2v),log=TRUE)
    B <- dinvgamma(S2,sigAlpha,sigBeta,log=TRUE)+
      LO(H=bigH,y=Y,beta=BETA,s2=S2,SIGMA=SIGMA,ZEROMEAN=ZEROMEAN)+dlnorm(S2new,log(S2),sqrt(S2v),log=TRUE)
    alpha <- min(c(0,AA-B))
    u <- log(runif(1))
    if(u<alpha){
      out[i,7] <- S2new
      if(i<adaptive){
        S2v=S2v+3*S2v/(100*sqrt(i))}
    }else{
      if(i<adaptive){
        S2v=S2v-S2v/(100*sqrt(i))}
    }
    #Update BETA
    if(isTRUE(ZEROMEAN)){
      out[i,1:6]<-rep(NA,6)
      #BETA <-rep(0,6)
    }else{
      out[i,1:6] <- out[i-1,1:6]
      if(q==6){#here
        for(j in c(2,3,4,6))
        {
          BETA <- as.numeric(out[i,1:6])
          betaNew <- rnorm(1,BETA[j],sqrt(BETAv[j]))
          BETANew <- BETA;BETANew[j]<-betaNew
          AA <- LO(H=bigH,y=Y,beta=BETANew,s2=out[i,7],SIGMA=SIGMA,ZEROMEAN=ZEROMEAN)+
            dnorm(betaNew,BETApriorM[j],sqrt(BETApriorV[j]),log=TRUE)
          B <- LO(H=bigH,y=Y,beta=BETA,s2=out[i,7],SIGMA=SIGMA,ZEROMEAN=ZEROMEAN)+
            dnorm(BETA[j],BETApriorM[j],sqrt(BETApriorV[j]),log=TRUE)
          alpha <- min(c(0,AA-B))
          u <- log(runif(1))
          if(u<alpha){
            out[i,j] <- betaNew
            if(i<adaptive){
              BETAv[j]=BETAv[j]+3*BETAv[j]/(100*sqrt(i))}
          }else{
            if(i<adaptive){
              BETAv[j]=BETAv[j]-BETAv[j]/(100*sqrt(i))}
          }
        }
        BETA <- as.numeric(out[i,1:6])
        SIG <- matrix(c(14,-0.58,-0.58,0.03),nrow=2)
        BETANew <- BETA
        BETANew[c(1,5)] <- mvtnorm::rmvnorm(1,c(BETA[c(1,5)]),SIG)
        AA <- LO(H=bigH,y=Y,beta=BETANew,s2=out[i,7],SIGMA=SIGMA,ZEROMEAN=ZEROMEAN)+
          mvtnorm::dmvnorm(BETA[c(1,5)],BETANew[c(1,5)],SIG,log=TRUE)+
          mvtnorm::dmvnorm(BETANew[c(1,5)],as.matrix(BETApriorM[c(1,5)],ncol=1),diag(BETApriorV[c(1,5)]),log=TRUE)
        B <- LO(H=bigH,y=Y,beta=BETA,s2=out[i,7],SIGMA=SIGMA,ZEROMEAN=ZEROMEAN)+
          mvtnorm::dmvnorm(BETANew[c(1,5)],BETA[c(1,5)],SIG,log=TRUE)+
          mvtnorm::dmvnorm(BETA[c(1,5)],as.matrix(BETApriorM[c(1,5)],ncol=1),diag(BETApriorV[c(1,5)]),log=TRUE)
        alpha <- min(c(0,AA-B))
        u <- log(runif(1))
        if(u<alpha){
          out[i,c(1,5)] <- BETANew[c(1,5)]
        }
        BETA <- out[i,1:6]
      }else if(q==1){
        j=1
        BETA <- as.numeric(out[i,1])
        betaNew <- rnorm(1,BETA[j],sqrt(BETAv[j]))
        BETANew <- BETA;BETANew[j]<-betaNew
        AA <- dnorm(BETANew,BETApriorM[j],sqrt(BETApriorV[j]),log=TRUE)+
          LO(H=bigH,y=Y,beta=BETANew,s2=out[i,7],SIGMA=SIGMA,ZEROMEAN=ZEROMEAN)
        B <- dnorm(BETA,BETApriorM[j],sqrt(BETApriorV[j]),log=TRUE)+
          LO(H=bigH,y=Y,beta=BETA,s2=out[i,7],SIGMA=SIGMA,ZEROMEAN=ZEROMEAN)
        alpha <- min(c(0,AA-B))
        u <- log(runif(1))
        if(u<alpha){
          out[i,j] <- betaNew
          if(i<adaptive){
            BETAv[j]=BETAv[j]+3*BETAv[j]/(100*sqrt(i))}
        }else{
          if(i<adaptive){
            BETAv[j]=BETAv[j]-BETAv[j]/(100*sqrt(i))}
        }
        BETA <- out[i,1]
      }#here
    }
    #Update the censored values
    if(isTRUE(ZEROMEAN)){
      muc <- mat.mult(mat.mult(Sigma12,Ai),y)
    }else{
      muc <- mat.mult(Hc,matrix(as.numeric(BETA),ncol=1)) + 
        mat.mult(mat.mult(Sigma12,Ai),(y-mat.mult(H,matrix(as.numeric(BETA),ncol=1))))
    }
    SigmaC <- out[i,7]*(Sigma11-mat.mult(mat.mult(Sigma12,Ai),Sigma21))
    out[i,14:ncol(out)] <- 
      TruncatedNormal::rtmvnorm(n=1, mu=c(muc), sigma=SigmaC,
                                lb=rep(CEN,nc), ub = rep(Inf,nc))
    Y <- c(as.numeric(out[i,14:ncol(out)]),y)
    #Update correlation lengths
    for(j in 1:5){
      THETA <- as.numeric(out[i,8:12])
      thetaNew <- rlnorm(1,log(THETA[j]),sqrt(CLv[j]))
      THETANew <- THETA;THETANew[j]<-thetaNew
      AA <- log(thetaNew) +
        LOtheta(DATA=DATA,H=bigH,y=Y,beta=BETA,s2=out[i,7],THETA=THETANew,
                nugget=nugget,CORRFUN=CORRFUN,ZEROMEAN=ZEROMEAN)+
        dexp(thetaNew,CLprior[j],log=TRUE)
      B <- log(THETA[j]) +
        LOtheta(DATA=DATA,H=bigH,y=Y,beta=BETA,s2=out[i,7],THETA=THETA,
                nugget=nugget,CORRFUN=CORRFUN,ZEROMEAN=ZEROMEAN)+
        dexp(THETA[j],CLprior[j],log=TRUE)
      alpha <- min(c(0,AA-B))
      u <- log(runif(1))
      if(u<alpha){
        out[i,7+j] <- thetaNew
        if(i<adaptive){
          CLv[j]=CLv[j]+3*CLv[j]/(100*sqrt(i))}
      }else{
        if(i<adaptive){
          CLv[j]=CLv[j]-CLv[j]/(100*sqrt(i))}
      }
    }
    #Nugget update
    nuggetNew <- rlnorm(1,log(nugget),sqrt(Nv))
    AA <- dinvgamma(nuggetNew,3,1,log=TRUE)+
      LOtheta(DATA=DATA,H=bigH,y=Y,beta=BETA,s2=out[i,7],THETA=as.numeric(out[i,8:12]),
              nugget=nuggetNew,CORRFUN=CORRFUN,ZEROMEAN=ZEROMEAN)+
      dlnorm(nugget,log(nuggetNew),sqrt(Nv),log=TRUE)
    B <- dinvgamma(nugget,3,1,log=TRUE)+
      LOtheta(DATA=DATA,H=bigH,y=Y,beta=BETA,s2=out[i,7],THETA=as.numeric(out[i,8:12]),
              nugget=nugget,CORRFUN=CORRFUN,ZEROMEAN=ZEROMEAN)+
      dlnorm(nuggetNew,log(nugget),sqrt(Nv),log=TRUE)
    alpha <- min(c(0,AA-B))
    u <- log(runif(1))
    if(u<alpha){
      out[i,13] <- nuggetNew
      if(i<adaptive){
        Nv=Nv+3*Nv/(100*sqrt(i))}
    }else{
      out[i,13] <- nugget
      if(i<adaptive){
        Nv=Nv-Nv/(100*sqrt(i))}
    }
    if(!is.null(filename)){
      write.table(out[i,],filename,append=T,row.names=F,col.names=F)
      write.table(CLv,"CLv.txt",row.names=F,col.names=F)
    }
    setTxtProgressBar(pb, i)
  }
  return(list(out,BETAv,S2v,CLv,Nv))
}