LOtheta <- function(DATA,H,y,beta,s2,THETA,nugget,CORRFUN,ZEROMEAN){
  if(isTRUE(ZEROMEAN)){
    mu <- matrix(rep(0,nrow(DATA)),ncol=1)
    Xs <- matrix(0,nrow=nrow(DATA),ncol=ncol(DATA))
    for(i in 1:ncol(Xs)) Xs[,i] <- as.numeric(DATA[,i])/as.numeric(THETA[i])
  }else{
    beta <- matrix(unlist(beta),ncol=1)
    mu <- mat.mult(as.matrix(H),beta)
    Xs <- matrix(0,nrow=nrow(H),ncol=ncol(DATA))
    for(i in 1:ncol(Xs)) Xs[,i] <- as.numeric(DATA[,i])/as.numeric(THETA[i])
  }
  if(CORRFUN=="Gaussian"){
    Sigma <- exp(-distance(Xs))+diag(nugget,nrow(DATA)) 
  }else if(CORRFUN=="Matern3_2"){
    D <- sqrt(distance(Xs))
    Sigma <- (1+sqrt(3)*D)*exp(-sqrt(3)*D)+diag(nugget,nrow(DATA))
  }else if(CORRFUN=="Matern5_2"){
    D <- sqrt(distance(Xs))
    Sigma <- (1+sqrt(5)*D+5/3*D^2)*exp(-sqrt(5)*D)+diag(nugget,nrow(DATA))
    }
  return(mvtnorm::dmvnorm(c(y),c(mu),s2*Sigma,log=TRUE))
}

LO <- function(H=NULL,y,beta=NULL,s2,SIGMA,ZEROMEAN){
  if(!is.null(beta)){
    beta <- matrix(unlist(beta),ncol=1)
  }
  if(isTRUE(ZEROMEAN)){
    mu <- rep(0,nrow(SIGMA))
  }else{
    mu <- mat.mult(as.matrix(H),beta)
  }
  return(mvtnorm::dmvnorm(c(y),c(mu),s2*SIGMA,log=TRUE))
}
